''
'' Demo to toggle pin 16 N times
''

CON
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000
  pin = 16

OBJ
  fds : "FullDuplexSerial.spin"

PUB run | i,x,now,elapsed

  '' start up the serial port
  fds.start(31, 30, 0, 115200)

  '' set up pin 16 as an output
  DIRA[pin] := 1
  OUTA[pin] := 0

  '' and now do the toggle
  now := cnt
  x := toggle(1000)
  elapsed := cnt - now
  fds.str(string("1000 toggles takes "))
  fds.dec(elapsed)
  fds.str(string(" cycles", 13, 10))

  '' now just hang
  fds.str(string("done", 13, 10))
  repeat

PUB toggle(n)
  REPEAT n
    !OUTA[pin]
