#include <stdio.h>
#include <propeller.h>

#define PIN 16
#define PINMASK (1<<16)

void
toggle(int n)
{
    int i;
    for (i = 0; i < n; i++) {
        OUTA ^= PINMASK;
    }
}

int
main()
{
    unsigned long elapsed;

    elapsed = CNT;
    toggle(1000);
    elapsed = CNT - elapsed;
    printf("1000 toggles takes %u cycles\n", elapsed);
    for(;;)
        ;
}
